﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Reports;
using Stimulsoft.Report;
using Stimulsoft.Report.Export;

namespace StimulsoftLicenceProblem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var report = new Report();
            report.Render();

            ExportAsJpeg(report);
        }

        private void ExportAsJpeg(StiReport report)
        {
            var settings = new StiJpegExportSettings();
            settings.ImageResolution = 100;
            settings.ImageFormat = StiImageFormat.Color;
            settings.ImageFormat = StiImageFormat.Monochrome;


            byte[][] pages = new byte[report.RenderedPages.Count][];
            for (int index = 0; index < report.RenderedPages.Count; index++)
            {
                string pageNumber = (index + 1).ToString();
                settings.PageRange = new StiPagesRange(pageNumber);
                using (MemoryStream exportedJpeg = new MemoryStream())
                {
                    report.ExportDocument(StiExportFormat.ImageJpeg, exportedJpeg, settings);
                    pages[index] = exportedJpeg.ToArray();
                }
            }
            //Displai first generated image for test
            image.Source = LoadImage(pages[0]);
        }

        private static BitmapImage LoadImage(byte[] imageData)
        {
            if (imageData == null || imageData.Length == 0) return null;
            var image = new BitmapImage();
            using (var mem = new MemoryStream(imageData))
            {
                mem.Position = 0;
                image.BeginInit();
                image.CreateOptions = BitmapCreateOptions.PreservePixelFormat;
                image.CacheOption = BitmapCacheOption.OnLoad;
                image.UriSource = null;
                image.StreamSource = mem;
                image.EndInit();
            }
            image.Freeze();
            return image;
        }

    }
}
